@rem  THIS PRODUCT CONTAINS RESTRICTED MATERIALS OF IBM
@rem  5724-I04 (C) COPYRIGHT International Business Machines Corp., 2005, 2007
@rem  All Rights Reserved * Licensed Materials - Property of IBM
@rem  US Government Users Restricted Rights - Use, duplication or disclosure
@rem  restricted by GSA ADP Schedule Contract with IBM Corp.
@echo off
setlocal

set IFIX=IC56080
set IFIX_LOG=%WVS_ROOT%\log\IC56080.log

echo  Ifix %IFIX%:
echo  THIS PRODUCT CONTAINS RESTRICTED MATERIALS OF IBM
echo  5724-I04 (C) COPYRIGHT International Business Machines Corp., 2005, 2007
echo  All Rights Reserved * Licensed Materials - Property of IBM
echo  US Government Users Restricted Rights - Use, duplication or disclosure
echo  restricted by GSA ADP Schedule Contract with IBM Corp.
echo.
echo    Please allow the ifix installation to run to completion. i.e. do not control-c 
echo.
echo    Please review the readme_IC56080.txt file delivered with this ifix
echo    before proceeding...
echo.
echo.
pause

@rem -------------------------------------------------------------------------------------
@rem Validating environment settings and parameters
@rem -------------------------------------------------------------------------------------
IF [%1] ==[] GOTO Syntax 

@rem Try to setup the WAS command line environment by using the default WAS install location

if EXIST "C:\Program Files\WebSphere\AppServer\bin\setupCmdLine.bat" goto setupwas
   GOTO checkenv
   
:setupwas
call "C:\Program Files\WebSphere\AppServer\bin\setupCmdLine.bat"

:checkenv         
@rem Check required Environment Variables are setup                      
IF  "%WAS_HOME%".== "". goto washome

IF  "%WVS_ROOT%".== "". goto wvsroot 

GOTO:parms

:Syntax
 @echo.
 @echo ifix_%IFIX%: WVS ifix %IFIX% Installer  
 @echo  to install ifix  syntax: ifix_%IFIX%.bat -install 
 @echo  to uninstall ifix  syntax: ifix_%IFIX%.bat -uninstall 
 @echo  off
 GOTO:EOF

:washome
  @echo.
  @echo ifix_%IFIX%: Please run WebSphere Application Servers setupCmdLine.bat to setup
  @echo          the WAS Command line environment
  @echo ifix_%IFIX%: The WebSphere Application Servers setupCmdLine.bat is located in WAS_HOME/bin directory.
  @echo.
  pause
  GOTO:EOF
  
:wvsroot
  @echo.
  @echo ifix_%IFIX%: Please configure WebSphere Voice Server wvs.setenv according
  @echo          to the WVS InfoCenter 
  @echo.
  pause
  GOTO:EOF

:parms
set installoption=false
set uninstalloption=false

:loop
if '%1'=='-install' goto installoption
if '%1'=='-uninstall' goto uninstalloption
if '%1'=='' goto syntax
goto syntax

:installoption
set installoption=true
GOTO:GO

:uninstalloption
set uninstalloption=true
GOTO:GO

:GO    

pushd  

if  "%installoption%" == "true" goto installparm

if  "%uninstalloption%" == "true" goto uninstallparm

:installparm 
  if NOT EXIST "%WVS_ROOT%\ifix\%IFIX%" goto installedfpcheck
    echo "ifix_%IFIX%: Ifix %IFIX% is applied, please uninstall before trying to reinstall ifix"
    goto:EOF

:installedfpcheck
  if EXIST "%WVS_ROOT%\fixes\5.1.3.3" goto installifix
    echo "ifix_%IFIX%: Ifix %IFIX% requires that FP3 is applied, please install FP3 before trying to reinstall ifix"
    goto:EOF
    
@rem -------------------------------------------------------------------------------------
@rem Everything ok, start installation procedure
@rem -------------------------------------------------------------------------------------    
:installifix  
 
  @rem # Check that the ifix files are found
  @echo ifix_%IFIX%: Checking for ifix files ...
  @echo ifix_%IFIX%: Checking for ifix files ...  >> "%IFIX_LOG%"
  if NOT EXIST "%~dp0adwEn_US.rst" goto missing

  @echo ifix_%IFIX%: Proceeding to install ifix
  @echo ifix_%IFIX%: Proceeding to install ifix >> "%IFIX_LOG%"
  @mkdir "%WVS_ROOT%\ifix\%IFIX%"

  echo ifix_%IFIX%: Stopping WebSphere Application Server
  echo ifix_%IFIX%: Stopping WebSphere Application Server >> "%IFIX_LOG%"
  call "%WAS_HOME%\bin\stopServer.bat" server1 -quiet >>      "%IFIX_LOG%"
  if ERRORLEVEL -10  ( 
    echo ifix_%IFIX%: WebSphere Application Server Successfully stopped. 
    echo ifix_%IFIX%: WebSphere Application Server Successfully stopped.  >> "%IFIX_LOG%"
  ) else (
    echo.
    echo ifix_%IFIX%: WebSphere Application Server Failed to stop Successfully. Exiting ifix installation.   
    echo ifix_%IFIX%: WebSphere Application Server Failed to stop Successfully.  Exiting ifix installation. >> "%IFIX_LOG%"
    echo %ERRORLEVEL% >>  "%IFIX_LOG%"
    goto:EOF
  )
  timeout /T 20 /NOBREAK  >>  "%IFIX_LOG%"
  
  copy /y "%~dp0ifix_%IFIX%.bat" "%WVS_ROOT%\ifix\."      >> "%IFIX_LOG%" 
    
@rem -------------------------------------------------------------------------------------
@rem Back up and replace all rst files
@rem -------------------------------------------------------------------------------------
:updateFiles
:updateEnUS
    set RST_FILE=%WVS_ROOT%\ViaVoice\vocabs\langs\En_US\addword\adwEn_US.rst
    if NOT EXIST "%RST_FILE%" goto updateEnUK
    echo updating %RST_FILE% >> "%IFIX_LOG%" 
    copy /y "%RST_FILE%" "%WVS_ROOT%\ifix\%IFIX%\adwEn_US.rst.bak" >> "%IFIX_LOG%"
    copy /y "%~dp0adwEn_US.rst" "%RST_FILE%" >> "%IFIX_LOG%"
:updateEnUK
    set RST_FILE=%WVS_ROOT%\ViaVoice\vocabs\langs\En_UK\addword\adwEn_UK.rst
    if NOT EXIST "%RST_FILE%" goto updateEnAU
    echo updating %RST_FILE% >> "%IFIX_LOG%" 
    copy /y "%RST_FILE%" "%WVS_ROOT%\ifix\%IFIX%\adwEn_UK.rst.bak" >> "%IFIX_LOG%"
    copy /y "%~dp0adwEn_UK.rst" "%RST_FILE%" >> "%IFIX_LOG%"
:updateEnAU
    set RST_FILE=%WVS_ROOT%\ViaVoice\vocabs\langs\En_AU\addword\adwEn_AU.rst
    if NOT EXIST "%RST_FILE%" goto updateEsES
    echo updating %RST_FILE% >> "%IFIX_LOG%" 
    copy /y "%RST_FILE%" "%WVS_ROOT%\ifix\%IFIX%\adwEn_AU.rst.bak" >> "%IFIX_LOG%"
    copy /y "%~dp0adwEn_AU.rst" "%RST_FILE%" >> "%IFIX_LOG%"
:updateEsES
    set RST_FILE=%WVS_ROOT%\ViaVoice\vocabs\langs\Es_ES\addword\adwEs_ES.rst
    if NOT EXIST "%RST_FILE%" goto updateFrCA
    echo updating %RST_FILE% >> "%IFIX_LOG%" 
    copy /y "%RST_FILE%" "%WVS_ROOT%\ifix\%IFIX%\adwEs_ES.rst.bak" >> "%IFIX_LOG%"
    copy /y "%~dp0adwEs_ES.rst" "%RST_FILE%" >> "%IFIX_LOG%"
:updateFrCA
    set RST_FILE=%WVS_ROOT%\ViaVoice\vocabs\langs\Fr_CA\addword\Fr_En_CA.rst
    if NOT EXIST "%RST_FILE%" goto updateGrGR
    echo updating %RST_FILE% >> "%IFIX_LOG%" 
    copy /y "%RST_FILE%" "%WVS_ROOT%\ifix\%IFIX%\Fr_En_CA.rst.bak" >> "%IFIX_LOG%"
    copy /y "%~dp0Fr_En_CA.rst" "%RST_FILE%" >> "%IFIX_LOG%"
:updateGrGR
    set RST_FILE=%WVS_ROOT%\ViaVoice\vocabs\langs\Gr_GR\addword\adwGr_GR.rst
    if NOT EXIST "%RST_FILE%" goto updateZhCN
    echo updating %RST_FILE% >> "%IFIX_LOG%" 
    copy /y "%RST_FILE%" "%WVS_ROOT%\ifix\%IFIX%\adwGr_GR.rst.bak" >> "%IFIX_LOG%"
    copy /y "%~dp0adwGr_GR.rst" "%RST_FILE%" >> "%IFIX_LOG%"
:updateZhCN
    set RST_FILE=%WVS_ROOT%\ViaVoice\vocabs\langs\Zh_CN\addword\adwZh_CN.rst
    if NOT EXIST "%RST_FILE%" goto updateJaJP
    echo updating %RST_FILE% >> "%IFIX_LOG%" 
    copy /y "%RST_FILE%" "%WVS_ROOT%\ifix\%IFIX%\adwZh_CN.rst.bak" >> "%IFIX_LOG%"
    copy /y "%~dp0adwZh_CN.rst" "%RST_FILE%" >> "%IFIX_LOG%"
:updateJaJP
    set RST_FILE=%WVS_ROOT%\ViaVoice\vocabs\langs\Ja_JP\addword\adwJa_JP.rst
    if NOT EXIST "%RST_FILE%" goto updateComplete
    echo updating %RST_FILE% >> "%IFIX_LOG%" 
    copy /y "%RST_FILE%" "%WVS_ROOT%\ifix\%IFIX%\adwJa_JP.rst.bak" >> "%IFIX_LOG%"
    copy /y "%~dp0adwJa_JP.rst" "%RST_FILE%" >> "%IFIX_LOG%"

:updateComplete
    echo.
    echo.
    echo ifix_%IFIX%: Ifix is now applied, please reboot the system 
    echo ifix_%IFIX%: Ifix is now applied, please reboot the system  >> "%IFIX_LOG%"    
    goto:EOF

:missing
    echo ifix_%IFIX%: Ifix files missing, please be sure this script is in same directory as the binary files
    goto:EOF	
	
@rem -------------------------------------------------------------------------------------
@rem Uninstalling ifix
@rem -------------------------------------------------------------------------------------    
:uninstallparm

if NOT "%uninstalloption%" == "true" goto :EOF

:uninstallifix

    @echo ifix_%IFIX%: Proceeding to un-install ifix 
    @echo ifix_%IFIX%: Proceeding to un-install ifix >> "%IFIX_LOG%"

    echo ifix_%IFIX%: Stopping WebSphere Application Server
    echo ifix_%IFIX%: Stopping WebSphere Application Server >> "%IFIX_LOG%"
    call "%WAS_HOME%\bin\stopServer.bat" server1 -quiet >> "%IFIX_LOG%"
    if ERRORLEVEL -10  ( 
        echo ifix_%IFIX%: WebSphere Application Server Successfully stopped. 
        echo ifix_%IFIX%: WebSphere Application Server Successfully stopped.  >> "%IFIX_LOG%"
    ) else (
        echo.
        echo ifix_%IFIX%: WebSphere Application Server failed to stop successfully. Exiting ifix installation.   
        echo ifix_%IFIX%: WebSphere Application Server failed to stop successfully.  Exiting ifix installation. >> "%IFIX_LOG%"
        echo %ERRORLEVEL% >>  "%IFIX_LOG%"
        goto:EOF
    )
    timeout /T 20 /NOBREAK  >>  "%IFIX_LOG%"


@rem -------------------------------------------------------------------------------------
@rem Restoring original rst files
@rem -------------------------------------------------------------------------------------    
:restoreFiles
:restoreEnUS
    set RST_FILE=%WVS_ROOT%\ViaVoice\vocabs\langs\En_US\addword\adwEn_US.rst
    set RST_BACKUP=%WVS_ROOT%\ifix\%IFIX%\adwEn_US.rst.bak
    if NOT EXIST "%RST_FILE%" goto restoreEnUK
    if NOT EXIST "%RST_BACKUP%" goto restoreEnUK
    echo restoring %RST_FILE% >> "%IFIX_LOG%" 
    copy /y "%RST_BACKUP%" "%RST_FILE%" >> "%IFIX_LOG%"
:restoreEnUK
    set RST_FILE=%WVS_ROOT%\ViaVoice\vocabs\langs\En_UK\addword\adwEn_UK.rst
    set RST_BACKUP=%WVS_ROOT%\ifix\%IFIX%\adwEn_UK.rst.bak
    if NOT EXIST "%RST_FILE%" goto restoreEnAU
    if NOT EXIST "%RST_BACKUP%" goto restoreEnAU
    echo restoring %RST_FILE% >> "%IFIX_LOG%" 
    copy /y "%RST_BACKUP%" "%RST_FILE%" >> "%IFIX_LOG%"
:restoreEnAU
    set RST_FILE=%WVS_ROOT%\ViaVoice\vocabs\langs\En_AU\addword\adwEn_AU.rst
    set RST_BACKUP=%WVS_ROOT%\ifix\%IFIX%\adwEn_AU.rst.bak
    if NOT EXIST "%RST_FILE%" goto restoreEsES
    if NOT EXIST "%RST_BACKUP%" goto restoreEsES
    echo restoring %RST_FILE% >> "%IFIX_LOG%" 
    copy /y "%RST_BACKUP%" "%RST_FILE%" >> "%IFIX_LOG%"
:restoreEsES
    set RST_FILE=%WVS_ROOT%\ViaVoice\vocabs\langs\Es_ES\addword\adwEs_ES.rst
    set RST_BACKUP=%WVS_ROOT%\ifix\%IFIX%\adwEs_ES.rst.bak
    if NOT EXIST "%RST_FILE%" goto restoreFrCA
    if NOT EXIST "%RST_BACKUP%" goto restoreFrCA
    echo restoring %RST_FILE% >> "%IFIX_LOG%" 
    copy /y "%RST_BACKUP%" "%RST_FILE%" >> "%IFIX_LOG%"
:restoreFrCA
    set RST_FILE=%WVS_ROOT%\ViaVoice\vocabs\langs\Fr_CA\addword\Fr_En_CA.rst
    set RST_BACKUP=%WVS_ROOT%\ifix\%IFIX%\Fr_En_CA.rst.bak
    if NOT EXIST "%RST_FILE%" goto restoreGrGR
    if NOT EXIST "%RST_BACKUP%" goto restoreGrGR
    echo restoring %RST_FILE% >> "%IFIX_LOG%" 
    copy /y "%RST_BACKUP%" "%RST_FILE%" >> "%IFIX_LOG%"
:restoreGrGR
    set RST_FILE=%WVS_ROOT%\ViaVoice\vocabs\langs\Gr_GR\addword\adwGr_GR.rst
    set RST_BACKUP=%WVS_ROOT%\ifix\%IFIX%\adwGr_GR.rst.bak
    if NOT EXIST "%RST_FILE%" goto restoreZhCN
    if NOT EXIST "%RST_BACKUP%" goto restoreZhCN
    echo restoring %RST_FILE% >> "%IFIX_LOG%" 
    copy /y "%RST_BACKUP%" "%RST_FILE%" >> "%IFIX_LOG%"
:restoreZhCN
    set RST_FILE=%WVS_ROOT%\ViaVoice\vocabs\langs\Zh_CN\addword\adwZh_CN.rst
    set RST_BACKUP=%WVS_ROOT%\ifix\%IFIX%\adwZh_CN.rst.bak
    if NOT EXIST "%RST_FILE%" goto restoreJaJP
    if NOT EXIST "%RST_BACKUP%" goto restoreJaJP
    echo restoring %RST_FILE% >> "%IFIX_LOG%" 
    copy /y "%RST_BACKUP%" "%RST_FILE%" >> "%IFIX_LOG%"
:restoreJaJP
    set RST_FILE=%WVS_ROOT%\ViaVoice\vocabs\langs\Ja_JP\addword\adwJa_JP.rst
    set RST_BACKUP=%WVS_ROOT%\ifix\%IFIX%\adwJa_JP.rst.bak
    if NOT EXIST "%RST_FILE%" goto restoreComplete
    if NOT EXIST "%RST_BACKUP%" goto restoreComplete
    echo restoring %RST_FILE% >> "%IFIX_LOG%" 
    copy /y "%RST_BACKUP%" "%RST_FILE%" >> "%IFIX_LOG%"

:restoreComplete
    echo.
    echo.
    echo ifix_%IFIX%: Ifix is now uninstalled, please reboot the system 
    echo ifix_%IFIX%:  Please remove the %WVS_ROOT%\ifix\%IFIX% directory before attempting a subsequent install of this ifix.
    echo ifix_%IFIX%: Ifix is now uninstalled, please reboot the system  >> "%IFIX_LOG%"      
    goto :END
     
popd
:END


